#include	<stddef.h>
#include	<ctype.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<unistd.h>	// for getopt

#include	"mckc.h"

extern void splitPath( const char *ptr, char *path, char *name, char *ext );
extern void makePath( char *ptr, const char *path, const char *name, const char *ext );
extern int  existCheck(const char *node);
extern char *skipSpace( char *ptr );
extern char *patchstr;
extern char *hogereleasestr;
extern char *forzaurus;

char	*mml_names[MML_MAX];
int		debug_flag = 0;
char	ef_name[256]  = "effect.h";
char	inc_name[256] = "define.inc";
char	out_name[256];
char	out_path[256];
char	dmc_path[10][512];
int		warning_flag = 1;
int		include_flag = 0;
int		mml_num = 0;
extern	int data_make( void );
extern	int		message_flag;			// ɽåν( 0:Jp 1:En )

/*------------------------------
	ե̾Ǹڤؤ
------------------------------*/
int checkLanguage(char *arg0)
{
	char path[256],name[256],ext[256];

	splitPath( arg0, path, name, ext );

	if( strlen(name) >= 2 ){
		if( !strcmp( name + strlen(name) -2 ,"_e" ) )
			message_flag = 1;
		if( !strcmp( name + strlen(name) -2 ,"_j" ) )
			message_flag = 0;
	}

	return 0;
}

/*--------------------------------------------------------------
	إɽ
 Input:

 Output:

--------------------------------------------------------------*/
void dispHelpMessage( void )
{
	if( message_flag == 0 ) {
#ifdef __MINGW32__
		puts(	"ˡ:ppmckc [switch] InputFile.mml [OutputFile.h]\n"
			"⤷:ppmckc [switch] -u InputFile1.mml InputFile2.mml ... \n"
				"\t[switch]\n"
				"\t-h -?   : إפɽ\\n"
				"\t-i      : /٥ץե˶ʥǡɲä\n"
				"\t-m<num> : 顼/˥ɽ\(0:Jpn 1:Eng)\n"
				"\t-o<str> : /٥ץեΥե̾<str>ˤ\n"
				"\t-w      : Warningåɽ\ޤ\n"
				"\t-u      : ʣϿNSF\n"
	    );
#else
		puts(	"ˡ:ppmckc [switch] InputFiles.mml... [OutputFile.h]\n"
				"\t[switch]\n"
				"\t-h -?   : إפɽ\n"
				"\t-i      : /٥ץե[effect.h]\n"
				"\t          ʥǡ[OutputFile.h]ɲä\n"
				"\t-m<num> : 顼/˥ɽ(0:Jpn 1:Eng)\n"
				"\t-o<str> : /٥ץե[effect.h]Υե̾<str>ˤ\n"
				"\t-p<pth> : եν<pth>ѹ\n"
				"\t-w      : Warningåɽޤ\n"
				"\t-u      : ʣϿNSF\n"
	    );
#endif

	} else {
		puts(	"Usage:ppmckc [switch] InputFiles.mml... [OutputFile.h]\n"
				"\t[switch]\n"
				"\t-h -?   : Display this help message\n"
				"\t-i      : Including song data in tone/envelope file\n"
				"\t-m<num> : Select message language(0:Jpn 1:Eng)\n"
				"\t-o<str> : Output tone/envelope file name is <str>\n"
				"\t-p<pth> : Output file path is <pth>\n"
				"\t-w      : Don't display warning message\n"
				"\t-u      : Multiple song NSF creation\n"
	    );
	}
	exit( 1 );
}



/*--------------------------------------------------------------
	ᥤ롼
 Input:
	int  argc		: ޥɥ饤θĿ
	char *argv[]	: ޥɥ饤Υݥ
 Output:
	0:ｪλ 0:ʳʾ彪λ
--------------------------------------------------------------*/
int main( int argc , char *argv[] )
{
	int	i,in,out;
	int	j,result;
	char	path[256],name[256],ext[256];
	int	multiple_song_nsf = 0;

	in = out = 0;

// ȥɽ
	printf( "MML to MCK Data Converter Ver %d.%02d by Manbow-J\npmck modification by BKC rel 0.2\n",
			(VersionNo/100), (VersionNo%100) );
	//printf("patches by [OK] and 2ch mck thread people\n");
	printf(patchstr);
	printf(hogereleasestr);
	printf(forzaurus);
// ޥɥ饤
	checkLanguage(argv[0]);
	if( argc == 1 ) {
		dispHelpMessage();
		return -1;
	}

	while (( result = getopt( argc, argv, "hxim:o:p:wu" )) != EOF ) {
			switch( toupper(result) ) {
			  case 'H':
			  case '?':
				dispHelpMessage();
				return 1;
			  case 'X':
				debug_flag = 1;
				break;
			  case 'I':
				include_flag = 1;
				break;
			  case 'M':
				message_flag = atoi( optarg );
				if( message_flag > 1 ) {
					dispHelpMessage();
					return 1;
				}
				break;
			  case 'N':
				//obsolete
				break;
			  case 'O':
				strcpy( ef_name, optarg );
				break;
			  case 'P':
				strcpy( out_path, optarg );
				break;
			  case 'W':
				warning_flag = 0;
				break;
			  case 'U':
				multiple_song_nsf = 1;
				break;
			  default:
				if( message_flag == 0 ) {
					puts( "åλ꤬㤤ޤ\n" );
				} else {
					puts( "Invalid switch!\n" );
				}
				dispHelpMessage();
				return -1;
			}
	}

	// /ϥեγǼ
	for(; optind < argc; optind++) {
			if ( in < MML_MAX ) {
				mml_names[in] = argv[optind];
				in++;
			} else {
				if( message_flag == 0 ) {
					puts( "ѥ᡼¿ޤ\n" );
				} else {
					puts( "Too many parameters!\n" );
				}
				dispHelpMessage();
				return -1;
			}

	}

	if (in == 0) {
		dispHelpMessage();
		return -1;
	}

	// ϥե̾
	splitPath( argv[argc -1], path, name, ext );
	if ( !strcmp(ext, ".h") || !strcmp(ext, ".inc") || !strcmp(ext, ".dat") ) {
		strcpy(out_name, name);
		strcat(out_name, ext);
		in--;
	} else {
		splitPath( mml_names[0], path, name, ext );
		makePath( out_name, "", name, ".h" );
	}

	// ե¸ߥå
	for(i = 0; i < in; i++){
		if(existCheck(mml_names[i])){
			if( message_flag == 0 ) {
				puts("ե뤬Ĥޤ\n");
			} else {
				puts( "File not found!\n");
			}
			return -1;
		}
	}

	// ϥǥ쥯ȥ¸ߥå
	if(existCheck(out_path) && strlen(out_path) > 0){
		if( message_flag == 0 ) {
			puts("ǥ쥯ȥ꤬Ĥޤ\n");
		} else {
			puts( "Directory not found!\n");
		}
		return -1;
	}

	// ϥեPATHղ
	splitPath(ef_name, path, name, ext );
	makePath( ef_name, "", name, ext );
	if(strlen(out_path)){
		if(out_path[strlen(out_path)-1] != '/'){
			strcat(out_path, "/");
		}
		splitPath(ef_name, path, name, ext );
		makePath( ef_name, out_path, name, ext );
		splitPath(inc_name, path, name, ext );
		makePath( inc_name, out_path, name, ext );
		splitPath(out_name, path, name, ext );
		makePath( out_name, out_path, name, ext );
	}

	// DMCPATH
	for(i = 0; i < in; i++){
		result = 1;
		splitPath(mml_names[i], path, name, ext);
		for(j = 0; j < i; j++){
			if( strcmp(dmc_path[i], dmc_path[j]) )
				result = 0;
		}
		if(result)
			strcpy( dmc_path[i], path );
	}

	// ѥ᡼å
	if( in > 1 )
		multiple_song_nsf = 1;
	if( in == 0){
		dispHelpMessage();
		return -1;
	}

	mml_num = in;
	for (i = 0; i < in - 1; i++) {
		printf("%s + ", mml_names[i]);
	}
	printf( "%s -> %s\n" ,mml_names[i],  out_name );
// С
	i = data_make();
// λ
	if (i == 0) {
		if( message_flag == 0 ) {
			puts( "\nλޤ\n" );
		} else {
			puts( "\nCompleated!\n" );
		}
		return EXIT_SUCCESS;
	} else {
		if( message_flag == 0 ) {
			puts( "\nѥ˼Ԥޤ\n" );
		} else {
			puts( "\nCompilation failed!\n" );
		}
		return EXIT_FAILURE;
	}
}

